﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Media.Imaging;
using System.IO;
//using System.Windows.Media;
//using System.Windows.Media.Imaging;

namespace KeyMaker
{
    public class PictureMaker
    {
        public int width = 26;
        public int height = 50;
        //protected int dpi = 96;

        protected Graphics graphics;
        protected string fontname = "Lucida Console";
        protected Font mainFont;
        protected Font subFont;
        protected SolidBrush mainBrush;
        protected SolidBrush subBrush;                

        public bool AntiAliasing { get; set; }

        public int YMain { get; set; }
        public int YSub { get; set; }

        protected Bitmap bitmap;

        public PictureMaker()
        {
            //18velky
            //this.mainFont = new Font(fontname, 18);
            this.mainFont = new Font(fontname, 14);
            this.subFont = new Font(fontname, 10);
            this.mainBrush = new SolidBrush(Color.White);            
            this.subBrush = new SolidBrush(Color.YellowGreen);            
            this.AntiAliasing = true;
            
        }

        public void setMainColor(Color c)
        {
            this.mainBrush.Color = c;
        }

        public void setSubColor(Color c)
        {
            this.subBrush.Color = c;
        }

        public void SetFont(FontFamily fontFamily, int MainSize, int SubSize)
        {
            this.fontname = fontFamily.Name;
            this.mainFont = new Font(fontFamily, MainSize);
            this.subFont = new Font(fontFamily, SubSize);            
        }

        public void SetMainSize(int size)
        {
            this.mainFont = new Font(this.mainFont.FontFamily, size);
        }

        public void SetSubSize(int size)
        {
            this.subFont = new Font(this.subFont.FontFamily, size); ;
        }

        public virtual void CreatePicture(string mainChar, string subChar = "")
        {
            //string spec = ",.?";
            string spec = "";   
                if(spec.IndexOf(mainChar) > -1)
                    this.CreatePictureImpl2(mainChar,subChar);
                else
                    this.CreatePictureImpl1(mainChar,subChar);

        }

        private void CreatePictureImpl1(string mainChar, string subChar = "")
        {
            this.bitmap = new System.Drawing.Bitmap(this.width, this.height);
            this.graphics = Graphics.FromImage(this.bitmap);
            if (this.AntiAliasing)
            {
                this.graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
                this.graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            }
            StringFormat sf = new StringFormat();
            sf.Alignment = StringAlignment.Center;
            int y = this.YMain;
            if (subChar.Length == 1)
                this.WriteSubCharacter(subChar);
            else
            {
                sf.LineAlignment = StringAlignment.Center;
                y = this.height / 2;
            }
            this.WriteMainCharacter(mainChar, sf, y);
        }

        private void CreatePictureImpl2(string mainChar, string subChar = "")
        {
            this.bitmap = new System.Drawing.Bitmap(this.width, this.height);
            this.graphics = Graphics.FromImage(this.bitmap);
            
            if (this.AntiAliasing)
            {
                this.graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
                //this.graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            }
            StringFormat sf = new StringFormat();
            sf.Alignment = StringAlignment.Center;
            int y = this.YMain;
            if (subChar.Length == 1)
                this.WriteSubCharacter(subChar);
            else
            {
                sf.LineAlignment = StringAlignment.Center;
                y = this.height / 2;
            }
            this.mainBrush = new SolidBrush(Color.White);
            this.WriteMainCharacter(mainChar, sf, y);
        }

        protected  void WriteMainCharacter(string mainChar,StringFormat sf, int y)
        {            
            this.graphics.DrawString(mainChar, this.mainFont, this.mainBrush, this.width / 2,y , sf);
            
            
        }

        protected void WriteSubCharacter(string subChar)
        {
         
            StringFormat sf = new StringFormat();
            sf.Alignment = StringAlignment.Center;
            
            this.graphics.DrawString(subChar, this.subFont, this.subBrush, this.width / 2, this.YSub, sf);

          
        }

        public void SaveImage(string filename)
        {
            filename = filename.ToLower();
            this.bitmap.Save(filename, System.Drawing.Imaging.ImageFormat.Png);
        }

        public MemoryStream SaveImage()
        {
            MemoryStream ms = new MemoryStream();
            this.bitmap.Save(ms,System.Drawing.Imaging.ImageFormat.Png);
            return ms;
        }
    }
}
